• Python 3

    From Ganiman@21:1/999 to All on Friday, November 04, 2022 21:04:05
    Does Mystic support Python 3? Will it ever? I don't see anything suggesting Mystic does and the Mystic website says 2.7, but in sometime April 2021 the Wikipedia page was updated to say "Embedded PYTHON 2.x and 3.x programming languages". It sure would make accomplishing some goals I have a lot easier
    if 3 is supported.

    Thanks in advance for any information surrounding this.

    --
    Ganiman

    --- Mystic BBS v1.12 A46 2020/08/26 (Linux/64)
    * Origin: Maid to Raid BBS (21:1/999)
  • From ogg@21:2/147 to Ganiman on Friday, November 04, 2022 16:26:57
    On 04 Nov 2022, Ganiman said the following...

    Does Mystic support Python 3? Will it ever? I don't see anything suggesting Mystic does and the Mystic website says 2.7, but in sometime April 2021 the Wikipedia page was updated to say "Embedded PYTHON 2.x
    and 3.x programming languages". It sure would make accomplishing some goals I have a lot easier if 3 is supported.

    Thanks in advance for any information surrounding this.

    --
    Ganiman

    I originally started Altair IV using Ubuntu. I had numerous issues when trying to use both Python2 and 3. I then switched to win10 and tried it again. No luck. Moved to win11 to try a "clean" slate and had problems with Python3 again. Removed it and have had no issues with 2.7 since.

    Now, this could all be user error but I've given up trying to use Python3. I'm even thinking of moving back to Ubuntu. If you try and get it to work, let us all know how you did it!

    ogg
    Sysop, Altair IV BBS
    fsxNet 21:2/147, fidonet 1:106/1
    altairiv.ddns.com:2323

    ... BREAKFAST.COM Halted... Cereal port not responding.

    --- Mystic BBS v1.12 A48 2022/07/15 (Windows/64)
    * Origin: Altair IV BBS (21:2/147)
  • From Ganiman@21:1/999 to ogg on Friday, November 04, 2022 22:37:06
    I am running this instance on Ubuntu - I am not a Windows user outside of gaming (and have even migrated to Linux for that recently). I will share if I can figure anything out, but at least with the version of Mystic I am running (which may be a couple behind) I only see one option for using embedded
    python, it is only looking for Python 2.7 libraries. I believe I could have Mystic run any program too, so that might be an option, but I think I'd lose the mysticbbs import and functions that come with it if I wanted to take advantage of them.

    Aside from a BBS (in dire need of some non-default art) I run and maintain a few other gaming related servers like Minecraft, Final Fantasy XI and
    anything else I care about. I'm looking to integrate the BBS with these other systems - for example I will show who is online in each game and where
    they are during the BBS login process, and maybe give some kind of "reward" in each game for using the BBS to entice users to try it out (and play LORD of course). With the lack of 'pip' support in 2.7 and 2.7 no longer recieving any security updates or maintenace (its essentially dead), it is difficult to do things like install a MySQL connector or other very useful libraries.

    Happy to hear more on this topic if someone has thoughts. Thanks!

    --
    Ganiman

    --- Mystic BBS v1.12 A46 2020/08/26 (Linux/64)
    * Origin: Maid to Raid BBS (21:1/999)
  • From ogg@21:2/147 to Ganiman on Friday, November 04, 2022 18:11:53
    if I can figure anything out, but at least with the version of Mystic I
    am running (which may be a couple behind) I only see one option for
    using embedded python, it is only looking for Python 2.7 libraries. I

    The version I'm running (mys112a48), also has a place for the python3
    library. It's just below the one for python2 (configuration/general settings). I even placed the library for python3 in the mystic home directory, but still had issues getting python3 files to run. Someone told me that there's an issue with Ubuntu, Mystic and python3. That's when I moved to windows.

    The only issue I'm facing now is easily finding 2.7 programming examples since I'm teaching myself python. "DuckDuckGo" has become my friend!

    ogg
    Sysop, Altair IV BBS
    fsxNet 21:2/147, fidonet 1:106/1
    altairiv.ddns.com:2323

    ... My software never has bugs. It just develops random features...

    --- Mystic BBS v1.12 A48 2022/07/15 (Windows/64)
    * Origin: Altair IV BBS (21:2/147)
  • From Ganiman@21:1/999 to Ganiman on Saturday, November 05, 2022 18:50:41
    Doesn't matter if I reconnect, restart Mystic, or what version I try. Libraries for both 2 and 3 are installed. Nothing in a log file. Even the most basic hello world script fails with this message. Not sure where to go from here really. Will have to wrestle with it some more later.

    I saw a reply suggesting I set the python library paths in the config. I didn't realize this was a thing in the newer version I installed. I've set the paths for both Python 2.7 and 3.8 and both versions seem to work just fine side by side now with my test scripts. My path for Python3 library differs from the answer I saw, which didn't actually point to a library (but might still work?) Anyway, awesome!

    For reference and clarity here is what I did. In Mystic config > Configuration Menu > General Settings:

    Python2 Library: /usr/lib/x86_64-linux-gnu/libpython2.7.so.1.0
    Python3 Library: /usr/lib/x86_64-linux-gnu/libpython3.8.so.1.0

    Fortunately I logged into another BBS and saw the reply suggesting this. For some reason I'm not recieving all replies/messages into this message base, but I'm going to assume that is because I don't have my own node number yet? I get some and not others, its not very consistent. Is this the kind of behavior I should expect while using an unregistered node id (999)? If anyone can confirm this, that'd be helpful.

    Thanks to the person who pointed me in the right direction - I'd reply directly, but the board I found the response on doesn't seem to have a working message editor and I couldn't compose or send from there.

    --
    Ganiman

    ... Message encrypted: Press ALT-F4 to read encoded message

    --- Mystic BBS v1.12 A47 2021/12/24 (Linux/64)
    * Origin: Maid to Raid BBS (21:1/999)
  • From esc@21:4/173 to Ganiman on Friday, November 04, 2022 21:46:12
    Does Mystic support Python 3? Will it ever? I don't see anything suggesting Mystic does and the Mystic website says 2.7, but in sometime April 2021 the Wikipedia page was updated to say "Embedded PYTHON 2.x
    and 3.x programming languages". It sure would make accomplishing some goals I have a lot easier if 3 is supported.

    It does...sort of.

    I think it works rather well in Windows but not linux. In linux, for example, if you run a python2 mpy script, you're not able to run a python3 mpy during that login session, and vice versa. And for some reason any python3 mpy I try to use that has external libraries doesn't seem to work right.

    As far as Windows....YMMV. :)

    --- Mystic BBS v1.12 A48 2022/07/11 (Linux/64)
    * Origin: m O N T E R E Y b B S . c O M (21:4/173)
  • From Ganiman@21:1/999 to esc on Saturday, November 05, 2022 05:41:31
    I think it works rather well in Windows but not linux. In linux, for example, if you run a python2 mpy script, you're not able to run a
    python3 mpy during that login session, and vice versa. And for some
    reason any python3 mpy I try to use that has external libraries doesn't seem to work right.

    I've upgraded Mystic to the latest and now if I try Python 2 or 3 I get:

    Cannot initialize Python, press a key

    Doesn't matter if I reconnect, restart Mystic, or what version I try.
    Libraries for both 2 and 3 are installed. Nothing in a log file. Even the
    most basic hello world script fails with this message. Not sure where to go from here really. Will have to wrestle with it some more later.

    --
    Ganiman

    ... I'm not a complete idiot... Several parts are missing!

    --- Mystic BBS v1.12 A47 2021/12/24 (Linux/64)
    * Origin: Maid to Raid BBS (21:1/999)
  • From opicron@21:3/126 to Ganiman on Saturday, November 05, 2022 07:27:34
    I've upgraded Mystic to the latest and now if I try Python 2 or 3 I get:

    Cannot initialize Python, press a key

    Be sure to set the config paths:

    Python2 Library /usr/local/lib/libpython2.7.so.1.0
    Python3 Library /usr/lib/python3.5

    It works here with above settings.

    oP!

    ... I'm not a complete idiot... Several parts are missing!

    --- Mystic BBS v1.12 A47 2021/12/24 (Linux/64)
    * Origin: TheForze - bbs.opicron.eu:23 (21:3/126)
  • From esc@21:4/173 to Ganiman on Saturday, November 05, 2022 03:50:12
    I've upgraded Mystic to the latest and now if I try Python 2 or 3 I get:

    Cannot initialize Python, press a key

    That's interesting. I don't have that on the latest prealpha - here's what I have as my path in mystic config for python2:

    /usr/lib/x86_64-linux-gnu/libpython2.7.so.1.0

    Make sure yu don't have any python3 scripts trying to run via mystic anywhere. Also don't launch 'mis' with sudo, it will cause these types of problems as well :)

    --- Mystic BBS v1.12 A48 2022/07/11 (Linux/64)
    * Origin: m O N T E R E Y b B S . c O M (21:4/173)
  • From Al@21:4/106 to Ganiman on Saturday, November 05, 2022 13:51:10
    Fortunately I logged into another BBS and saw the reply suggesting this. For
    some reason I'm not recieving all replies/messages into this message base, but >I'm going to assume that is because I don't have my own node number yet? I get
    some and not others, its not very consistent. Is this the kind of behavior I
    should expect while using an unregistered node id (999)? If anyone can confirm
    this, that'd be helpful.

    That sounds like there is more than one node testing with the temp 999 address. Someone else is also picking up mail for that node so you only see some of the traffic when that happens.

    Once you have your own node setup that won't happen.

    --- BBBS/Li6 v4.10 Toy-6
    * Origin: The Rusty MailBox - Penticton, BC Canada (21:4/106)
  • From Ganiman@21:1/999 to esc on Sunday, November 06, 2022 03:51:48
    Hi, are you using Python2 or Python3? And...are you using /both at the same time/??? If so, I would love to chat :)

    I have both configured, but am mostly working with Python 3. They both "work" but as someone mentioned before, if you start a script from one version, then try another from the other version, it'll crash your session and you have to reconnect.

    Seems like Mystic might not be unloading the library after its used or something like that. It would be nice to not have this "bug" because I'm sure older boards are more dependent on 2.7 with all the neat addons that are out there. If I stick with 3.8 it seems happy enough, so I'll see how long I can get away with that.

    --
    Ganiman

    ... Message encrypted: Press ALT-F4 to read encoded message

    --- Mystic BBS v1.12 A47 2021/12/24 (Linux/64)
    * Origin: Maid to Raid BBS (21:1/999)
  • From esc@21:4/173 to Ganiman on Saturday, November 05, 2022 23:00:22
    Seems like Mystic might not be unloading the library after its used or something like that. It would be nice to not have this "bug" because I'm sure older boards are more dependent on 2.7 with all the neat addons
    that are out there. If I stick with 3.8 it seems happy enough, so I'll
    see how long I can get away with that.

    I use 2.7 merely because the mods on my BBS are written with that version in mind. I suppose I could update things to work with 3.x but I recall there are some weird encoding things that would need to be changed.

    I agree getting rid of this bug would be killer. Hopefully g00r00 comes back to work on Mystic some time soon.

    --- Mystic BBS v1.12 A48 2022/07/11 (Linux/64)
    * Origin: m O N T E R E Y b B S . c O M (21:4/173)